; ##################
; The bit at the top
; ##################

.386
.model flat, stdcall
option casemap:none

; ########
; Includes
; ########

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\masm32.inc

include ddraw.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\masm32.lib

includelib ddraw.lib
includelib dxguid.lib

; ######
; Macros
; ######

return MACRO ARG
	IFNB <ARG>
		IF (OPATTR (ARG)) AND 00000100y
			IF ARG EQ 0
				xor eax, eax
			ELSE
				mov eax, ARG
			ENDIF
		ELSEIFDIFI <eax>, <ARG>
			mov eax, ARG
		ENDIF
	ENDIF
	ret
ENDM

; ##########
; Prototypes
; ##########

WinMain			PROTO :HINSTANCE, :HINSTANCE, :LPSTR, :DWORD
WndProc			PROTO :HWND, :UINT, :WPARAM, :LPARAM
DD_Init			PROTO :DWORD, :DWORD, :DWORD, :HWND
DD_ShutDown		PROTO
DD_Main			PROTO

; ################
; Initialised data
; ################

.data

szClassName		db "DD7Test", 0
szAppName		db "Direct Draw 7 test", 0

szErrCreateDD	db "CreateDirectDraw Failed", 0
szErrQueryDD7	db "Query for DirectDraw7 Failed", 0
szErrSetCoop	db "Setting of Cooperative Level Failed", 0
szErrSetMode	db "Setting of Display Mode Failed", 0
szErrPrimSur	db "Aquisition of Primary Surface Failed", 0
szErrBackSur	db "Aquisition of Back Buffer Surface Failed", 0

; ################
; Unitialised data
; ################

.data?

lpdd7			LPDIRECTDRAW7 ?
lpdds7_Primary	LPDIRECTDRAWSURFACE7 ?
lpdds7_Back		LPDIRECTDRAWSURFACE7 ?

hInstance		HINSTANCE ?
pszCmndLine		LPSTR ?

dwX				dd ?
dwY				dd ?

; ####
; Code
; ####

.code
start:

	invoke GetModuleHandle, NULL
	mov hInstance, eax
	
	invoke GetCommandLine
	mov pszCmndLine, eax
	
	invoke WinMain, hInstance, NULL, pszCmndLine, SW_SHOWDEFAULT
	
	invoke ExitProcess, eax

; *****************************************
; The normal thing with a few modifications
; *****************************************

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, pszCmdLine:LPSTR, dwCmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hWnd:HWND

	; ===========================
	; Fill in the class structure
	; ===========================

	mov   wc.cbSize, 		sizeof(WNDCLASSEX)
	mov   wc.style, 		CS_HREDRAW OR CS_VREDRAW
	mov   wc.lpfnWndProc, 	offset WndProc
	mov   wc.cbClsExtra, 	NULL
	mov   wc.cbWndExtra, 	NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,	COLOR_WINDOW+1
	mov   wc.lpszMenuName, 	NULL
	mov   wc.lpszClassName, offset szClassName
	invoke LoadIcon, NULL, IDI_APPLICATION
	mov   wc.hIcon, 		eax
	mov   wc.hIconSm, 		eax
	invoke LoadCursor, NULL, IDC_ARROW
	mov   wc.hCursor, 		eax
	
	; ===========
	; Register it
	; ===========
	
	invoke RegisterClassEx, addr wc
	
	; =================
	; Create the window
	; =================
	
	invoke CreateWindowEx, NULL, addr szClassName, addr szAppName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInst, NULL
	mov hWnd, eax

	; ====================
	; Do the DD init stuff
	; ====================
	
	invoke DD_Init, 640, 480, 32, hWnd
	
	.if eax != TRUE
		return 0
	.endif

	; =======
	; Show it
	; =======

	invoke ShowWindow, hWnd, SW_SHOWNORMAL
	invoke UpdateWindow, hWnd
	
	; =========
	; Main loop
	; =========
	
	.while TRUE
		invoke PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE
		.if eax != 0
			.break .if msg.message == WM_QUIT
			invoke TranslateMessage, addr msg
			invoke DispatchMessage, addr msg
		.else
			invoke DD_Main
			.if eax != TRUE
				.break
			.endif
		.endif
	.endw

	; ============
	; Shut it down
	; ============

	invoke DD_ShutDown

	return msg.wParam
WinMain endp

; *********
; The usual
; *********

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if uMsg == WM_DESTROY
		invoke PostQuitMessage, NULL
	.else
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		return
	.endif
	
	return 0
WndProc endp

; *********************************************************************
; Initialises all of the Direct Draw 7 stuff (to how I usually have it)
; *********************************************************************

DD_Init PROC dwScreenWidth:DWORD, dwScreenHeight:DWORD, dwScreenBPP:DWORD, hMainWnd:HWND
	LOCAL lpdd:LPDIRECTDRAW
	LOCAL ddsd2:DDSURFACEDESC2
	LOCAL ddsc2:DDSCAPS2

	; ============================================
	; Create a normal DDraw interface for starters
	; ============================================
	
	invoke DirectDrawCreate, NULL, addr lpdd, NULL
	
	.if eax != DD_OK
		invoke MessageBox, hMainWnd, addr szErrCreateDD, addr szAppName, MB_OK
	
		return FALSE
	.endif

	; =======================================================
	; Query for DDraw7 (should work as long as its installed)
	; =======================================================

	stdinvoke IDirectDraw, QueryInterface, lpdd, addr IID_IDirectDraw7, addr lpdd7
	
	.if eax != DD_OK
		stdinvoke IDirectDraw, Release, lpdd
	
		invoke MessageBox, hMainWnd, addr szErrQueryDD7, addr szAppName, MB_OK
	
		return FALSE
	.endif
	
	; =================
	; Release it anyway
	; =================
	
	stdinvoke IDirectDraw, Release, lpdd
	
	; ===================================================
	; Set cooperative level to fullscreen, exclusive, etc
	; ===================================================
	
	stdinvoke IDirectDraw7, SetCooperativeLevel, lpdd7, hMainWnd, (DDSCL_ALLOWMODEX or DDSCL_FULLSCREEN or DDSCL_EXCLUSIVE or DDSCL_ALLOWREBOOT)
	
	.if eax != DD_OK
		stdinvoke IDirectDraw7, Release, lpdd7
	
		invoke MessageBox, hMainWnd, addr szErrSetCoop, addr szAppName, MB_OK
	
		return FALSE
	.endif

	; ===========================================
	; Set the Display Mode to the required values
	; ===========================================

	stdinvoke IDirectDraw7, SetDisplayMode, lpdd7, dwScreenWidth, dwScreenHeight, dwScreenBPP, 0, 0

	.if eax != DD_OK
		stdinvoke IDirectDraw7, Release, lpdd7
	
		invoke MessageBox, hMainWnd, addr szErrSetMode, addr szAppName, MB_OK
	
		return FALSE
	.endif

	; ===================================
	; Setup to create the primary surface
	; ===================================
	
	invoke RtlZeroMemory, addr ddsd2, sizeof(DDSURFACEDESC2)

	mov ddsd2.dwSize,				sizeof(DDSURFACEDESC2)
	mov	ddsd2.dwFlags,				DDSD_CAPS OR DDSD_BACKBUFFERCOUNT
	mov	ddsd2.ddsCaps.dwCaps,		DDSCAPS_PRIMARYSURFACE OR DDSCAPS_FLIP OR DDSCAPS_COMPLEX
	mov	ddsd2.dwBackBufferCount,	1
	
	; ==============================
	; Now create the primary surface
	; ==============================
	
	stdinvoke IDirectDraw7, CreateSurface, lpdd7, addr ddsd2, addr lpdds7_Primary, NULL

	.if eax != DD_OK
		stdinvoke IDirectDraw7, Release, lpdd7
	
		invoke MessageBox, hMainWnd, addr szErrPrimSur, addr szAppName, MB_OK
	
		return FALSE
	.endif

	; ================
	; Get a backbuffer
	; ================
	
	invoke RtlZeroMemory, addr ddsc2, sizeof(DDSCAPS2)
	
	mov	ddsc2.dwCaps,				DDSCAPS_BACKBUFFER
	
	stdinvoke IDirectDrawSurface7, GetAttachedSurface, lpdds7_Primary, addr ddsc2, addr lpdds7_Back

	.if eax != DD_OK
		stdinvoke IDirectDrawSurface7, Release, lpdds7_Primary
		stdinvoke IDirectDraw7, Release, lpdd7
	
		invoke MessageBox, hMainWnd, addr szErrBackSur, addr szAppName, MB_OK

		return FALSE
	.endif

	return TRUE
DD_Init ENDP

; *********************************
; Shuts down all of the DDraw stuff
; *********************************

DD_ShutDown PROC
	stdinvoke IDirectDrawSurface7, Release, lpdds7_Back
	stdinvoke IDirectDrawSurface7, Release, lpdds7_Primary
	stdinvoke IDirectDraw7, Release, lpdd7
	
	return TRUE
DD_ShutDown ENDP

; ****************************************************
; This is where the stuff that does what you want goes
; ****************************************************

DD_Main PROC
	LOCAL hDC:HDC

	stdinvoke IDirectDrawSurface7, GetDC, lpdds7_Back, addr hDC
	
	.if eax != DD_OK
		return FALSE
	.endif

	invoke Sleep, 40

	add dwX, 1
	add dwY, 1

	.if dwX > 600
		mov dwX, 0
	.endif

	.if dwY > 400
		mov dwY, 0
	.endif

	invoke BitBlt, hDC, 0, 0, 640, 480, NULL, 0, 0, BLACKNESS
	invoke TextOut, hDC, dwX, dwY, addr szClassName, 7

	stdinvoke IDirectDrawSurface7, ReleaseDC, lpdds7_Back, hDC

	.if eax != DD_OK
		return FALSE
	.endif

	; =============
	; Flip surfaces
	; =============

	stdinvoke IDirectDrawSurface7, Flip, lpdds7_Primary, NULL, DDFLIP_WAIT

	.if eax != DD_OK
		return FALSE
	.endif

	return TRUE
DD_Main ENDP

end start





















